/* sqw-msg.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Generating messages subroutines.   ணࠬ 樨 ᮮ饭. -
 * Assume fileout to be opened.       㬥,     fileout.
 *
 * Assume link is in our Link[] ta-   ࠧ㬥,  link  ⠡窥 
 * ble if link is non-zero, and  is    㫥  ࠭  Link[0].
 * kept in Link[0] if  non-zero. It
 * simplifies logic of these  func-
 * tions.
 *
 */

#include "./sqw-inc.h"

/*
 * Generates and write header and          .
 * technical kludjes.
 *
 */

static unsigned int _arorigin;

void msg_netmail_begin(
unsigned int link,		/* link number in table. Addres To: of msg. */
unsigned int arorig,		/* My address number in table. AddrFrom:    */
char *from,			/* From field				    */
char *to,			/* To field				    */
char *subj			/* Subj field				    */
)
{

_arorigin = arorig;
mh.PakdMessage = 2;
mh.AttributeWord = 0;

mh.destNode = Link[link].Node;
mh.destNet  = Link[link].Net;

mh.origNode = My[arorig].Node;
mh.origNet  = My[arorig].Net;

mhdatime(&mh);

fwrite(&mh, sizeof(mh),1,fileout);		/* Header written */
fputs (to, fileout); fputc('\0', fileout);
fputs (from, fileout); fputc('\0', fileout);
fputs (subj, fileout); fputc('\0', fileout);

/*
 * If another Zone or  ForceINTL  -
 * kludge INTL added.
 */

if (Cfg_ForceINTL || (Link[link].Zone != My[arorig].Zone))
   fprintf (fileout,  Format_INTL,
    Link[link].Zone, Link[link].Net, Link[link].Node,
    My[arorig].Zone, My[arorig].Net, My[arorig].Node);
else;

/*
 * If point address from - FMPT.
 */

if (My[arorig].Point) fprintf(fileout, Format_FMPT, My[arorig].Point);
else;

/*
 * If point address to - TOPT.
 */

if (Link[link].Point) fprintf(fileout, Format_TOPT, Link[link].Point);
else;

fprintf(fileout, Format_MSGID,
	My[arorig].Zone, My[arorig].Net, My[arorig].Node,(unsigned long)ttt);

if (Cfg_UseREPLY && Reply_Line) fputs(Reply_Line, fileout); else;

} /* msg_netmail_begin() */

/*
 * Finishes  message  with  writing   蠥 ᮮ饭   ,  -
 * buffer, tearline and  last  zero   ૠ    ᫥  㫥   
 * byte to fileout. Checks error of   fileout. ஢ઠ 訡 . ᫨ -
 * writing. If success - returns 1.   譮 - 頥 1.  ᫨ 訡 - -
 * If error detected - returns 0.     頥 0.
 *
 */

int msg_netmail_end(char *buffer, char *progress)
{
int length_Origin = 78 - 13;

fprintf(fileout, Format_rsr, buffer);		/* text itself (invalidated) */
fprintf(fileout, sVersion, rTear,		/* tearline */
	SQW_VERTYPE, SQW_VERSION, SQW_SUBVERS, your_compiler);
if (Cfg_AddOrigin && Origin)
     {
     length_Origin -= sprintf(Buffer,Format_4D, My[_arorigin].Zone,
	      My[_arorigin].Net, My[_arorigin].Node, My[_arorigin].Point);
     fprintf(fileout, "\r * Origin: %.*s(%s)", length_Origin, Origin, Buffer);
     }
else;
fputc('\r', fileout);                           /* End of message            */
fputc('\0', fileout);                           /* Last zero byte of message */
if (ferror(fileout))
	{
	OutLog2(LEV_LOOSE,progress, Write_Error);
	return 0;
	}
else	return 1;
} /* msg_netmail_end() */
