/* moveback.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Special small programm for  UNIX   樠쭮 ᠭ  UNIX ணࠬ,
 * moves files  from  directory  to   ६ 䠩   ४ਨ  
 * another with renaming them using     २,  ᯮ짮-
 * 'DOS-style' idea of 'file exten-    ""  ࠡ    "७ﬨ"
 * tion' - three symbols after dot.   䠩 -  ᨬ ᫥ 窨.
 *
 * Used in toss.                      ᯮ  䠩 toss.
 *
 * stdout is used for 'progress-in-   stdout ᯮ   ண--
 * dicator, showing moved files.      , 뢠饣 ६頥 䠩.
 *
 * Note, that you don't  need  this   ⨬,     ணࠬ  -
 * program under DOS shells -  move    -    筮 
 * command is enough under  DOS  to   move  믮 ⮩  ࠡ.
 * do the same job. ;)
 */

#include <stdio.h>

#define LENGTH 8192

FILE *fin, *fout;
unsigned char Buffer[LENGTH+1], *s0, *s1, *s2, *s3, fname[LENGTH+1];
unsigned int tab22[256];
int c, i, j, k, c0;

void main(int argc, char **argv)
{

if (argc <= 3)
	{
	puts("Utility moves files described i filein to dirout with renaming to *.ext");
	puts("Usage:");
	puts("moveback dirout/ ext filein");
	puts("Errorlevels:");
	puts("0 - Success; 1 - not enough command line;");
	puts("2 - no file; 3 - infiles are without extention");
	puts("4 - Error when moving files");
	exit(1);
	}
else;

#if (defined(UNIX) || (!defined(__TURBOC__)))
mkdir(argv[1],0777);
#define BACKSLASH '/'
#else
mkdir(argv[1]);
#define BACKSLASH '\\'
#endif

fputs(argv[1], stdout); fputs("<-",stdout);
strcpy(fname,argv[1]);
s1 = fname + strlen(fname); /* s1 points to end of outpath */

c0 = '(';
for (i =  3; i < argc; i++)
   {
   if (argc > 3) putc(c0,stdout); else;
   c0 = ',';
/* divide argv[i] to: path; name; ext */
   j = k = strlen(argv[i]);
   s2 = argv[i] + j;
   while ((j-- > 0) && (*s2 != '.')) s2--; /* s2 points to old .ext */
   s3 = argv[i] + k;
   while ((k-- > 0) && (*s3 != BACKSLASH)) s3--;
   if (*s3 == BACKSLASH) s3++; else;		/* s3 points to fname */
   if ((j == 0) || (j < k)) exit(3); else;
   
   fputs(s3,stdout);
   strcpy(s1,s3);		/* Now fname contains full outfile name */
   strcpy(s1+j-k, argv[2]);	/* Now correct extention added to fname */

   if (rename(argv[i],fname))	/* Trivial renaming */
      exit(4);
   else;
   } /* for i < argc */
if (argc > 3) putc(')',stdout); else; /* finish output list if needed */
putc('\n', stdout);
exit(0);
} /* main() */
